## fabulous 0.3.0+dfsg1

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  qthelp    to make HTML files and a qthelp project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/nemesis.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/nemesis.qhc"

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

## fabulous 0.1.5+dfsg1

=== debian/changelog ===
fabulous (0.1.5+dfsg1-1) unstable; urgency=low

  * Initial release. (Closes: #705947)
  * The licensing of the fonts file is unclear, hence removal from the source
    package.
  * Patch the except: statements to always specify a type.

 -- Simon Chopin <chopin.simon@gmail.com>  Mon, 08 Jul 2013 19:45:29 -0400

=== debian/control ===
Source: fabulous
Section: python
Priority: optional
Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Uploaders: Simon Chopin <chopin.simon@gmail.com>
Build-Depends:
 debhelper (>= 9),
 python-all (>= 2.6.6-3~),
 python-grapefruit,
 python-sphinx (>= 1.0.7+dfsg),
 python-setuptools
Standards-Version: 3.9.4
X-Python-Version: >= 2.6
Homepage: http://lobstertech.com/fabulous.html
Vcs-Svn: svn://anonscm.debian.org/python-modules/packages/fabulous/trunk
Vcs-Browser: http://anonscm.debian.org/viewsvn/python-modules/packages/fabulous/trunk/

Package: python-fabulous
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Description: Python module to make your terminal output fabulous
 Fabulous is a Python library designed to make the output of terminal
 applications look fabulous. Fabulous allows you to print colors, images, and
 stylized text to the console (without curses.) Fabulous also offers features
 to improve the usability of Python's standard logging system.

Package: python-fabulous-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Python module to make your terminal output fabulous - documentation
 Fabulous is a Python library designed to make the output of terminal
 applications look fabulous. Fabulous allows you to print colors, images, and
 stylized text to the console (without curses.) Fabulous also offers features
 to improve the usability of Python's standard logging system.
 .
 This package provides the documentation for fabulous.

=== debian/rules ===
#!/usr/bin/make -f
CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
%:
	dh $@ --with python2,sphinxdoc

build-arch:
	mkdir -p debian/tmp
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -fPIC -shared -o xtermspeedup.so fabulous/_xterm256.c

override_dh_auto_build-indep:
	dh_auto_build -i
	PYTHONPATH=$(shell pwd) make -C docs/ html

override_dh_auto_install-arch:
	dh_auto_install -a
	rm -f debian/tmp/usr/lib/python2*/dist-packages/fabulous*.egg-info/SOURCES.txt
	mv xtermspeedup.so debian/tmp

override_dh_auto_clean:
	dh_auto_clean
	rm -rf docs/_build

override_dh_sphinxdoc-arch:

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg\d+// \
http://lobstertech.com/fabulous.html /media/file/fabulous/fabulous-(.*)\.tar\.gz debian debian/repack.sh

## fabulous 0.3.0%2Bdfsg1

=== debian/changelog ===
fabulous (0.3.0+dfsg1-6) unstable; urgency=medium

  * Move examples back to documentation directory

 -- Jonathan Carter <jcc@debian.org>  Tue, 04 Dec 2018 11:50:49 +0200

fabulous (0.3.0+dfsg1-5) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

  [ Jonathan Carter ]
  * Add Breaks+Replaces relationship to python-fabulous
    (Closes: #909913)
  * Replace -doc package and deploy rst file in python-fabulous
    (Closes: #910417)

 -- Jonathan Carter <jcc@debian.org>  Mon, 08 Oct 2018 14:13:19 +0200

fabulous (0.3.0+dfsg1-4) unstable; urgency=medium

  * Version bump (no further changes)

 -- Jonathan Carter <jcc@debian.org>  Fri, 28 Sep 2018 09:20:48 +0200

fabulous (0.3.0+dfsg1-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Remove ancient X-Python-Version field
  * d/changelog: Remove trailing whitespaces
  * Convert git repository from git-dpm to gbp layout

  [ Jonathan Carter ]
  * Migrate from python2 to python3 package
  * Update standards version to 4.2.1
  * Add font-noto as dependency
  * wrap-and-sort

 -- Ondřej Nový <onovy@debian.org>  Mon, 14 May 2018 08:04:25 +0200

fabulous (0.3.0+dfsg1-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org
  * d/copyright: Use https protocol in Format field

  [ Jonathan Carter ]
  * Adopting package (Closes: #889777)
  * Update compate/debhelper to version 11
  * Update standards version to 4.1.4

 -- Jonathan Carter <jcc@debian.org>  Sun, 29 Apr 2018 13:02:21 +0200

fabulous (0.3.0+dfsg1-1) unstable; urgency=low

  * Team upload.
  * New upstream release
  * Fixed VCS URL (https)
  * d/copyright: Use Files-Excluded to remove non-DFSG files
  * Changed project homepage to new one
  * Use local objects.inv for intersphinx mapping (Closes: #830556)
  * Standards-Version is 3.9.8 now (no changes needed)
  * d/rules: Don't remove non-existent SOURCES.txt from egg-info
  * d/control: Removed pre-wheezy versioned dependencies
  * Enabled autopkgtest-pkg-python testsuite
  * Added dh-python and python-sphinxcontrib.programoutput to build depends
  * Added python-pil to (build-)depends (Closes: #805475)
  * Added fonts-noto-hinted to recommends (Closes: #805473)
  * Install AUTHORS file
  * d/copyright
    - Added more copyright holders
    - Added myself for Debian part
    - Upstream relicensed to Apache-2
  * Install examples into docs examples directory

 -- Ondřej Nový <onovy@debian.org>  Sun, 14 Aug 2016 14:11:56 +0200

## fabulous 0.3.0+dfsg1

=== debian/changelog ===
fabulous (0.3.0+dfsg1-8) unstable; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Ondřej Nový ]
  * d/control: Update Maintainer field with new Debian Python Team
    contact address.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

  [ Jonathan Carter ]
  * Update debhelper-compat to level 13
  * Add lintian-override for shared-library-lacks-prerequisites
    (this binary has no prerequisites)

 -- Jonathan Carter <jcc@debian.org>  Thu, 22 Oct 2020 12:06:47 +0200

fabulous (0.3.0+dfsg1-7) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.

  [ Jonathan Carter ]
  * Fix debian/rules for building xtermspeedup.so (Closes: #952242)
  * Update standards version to 4.5.0
  * Update debhelper-compat to level 12
  * Declare Rules-Requires-Root: no
  * Update copyright years

 -- Jonathan Carter <jcc@debian.org>  Fri, 17 Apr 2020 20:25:27 +0200

=== debian/control ===
Source: fabulous
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Jonathan Carter <jcc@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               python3-all,
               python3-doc,
               python3-minimal,
               python3-pil,
               python3-setuptools,
               python3-sphinx,
               python3-sphinxcontrib.programoutput
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://jart.github.io/fabulous/
Vcs-Git: https://salsa.debian.org/python-team/packages/fabulous.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/fabulous
Testsuite: autopkgtest-pkg-python

Package: python3-fabulous
Breaks: python-fabulous, python-fabulous-doc, python3-fabulous-doc
Replaces: python-fabulous, python-fabulous-doc, python3-fabulous-doc
Architecture: any
Depends: fonts-noto,
         python3-pil,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         ${sphinxdoc:Depends}
Description: Python module to make your terminal output fabulous
 Fabulous is a Python library designed to make the output of terminal
 applications look fabulous. Fabulous allows you to print colors, images, and
 stylized text to the console (without curses.) Fabulous also offers features
 to improve the usability of Python's standard logging system.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_build:
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) -fPIC -shared -o xtermspeedup.so fabulous/_xterm256.c
	dh_auto_build


override_dh_auto_build-indep:
	dh_auto_build -i
	PYTHONPATH=$(shell pwd) make -C docs/ html

override_dh_auto_install-arch:
	dh_auto_install -a
	rm \
		debian/python3-fabulous/usr/lib/python3*/dist-packages/fabulous/balls.png \
		debian/python3-fabulous/usr/lib/python3*/dist-packages/fabulous/demo.py

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/python3-fabulous/usr/share/doc/python3-fabulous/examples
	mv debian/python3-fabulous/usr/bin/fabulous-* \
	   debian/python3-fabulous/usr/share/doc/python3-fabulous/examples

override_dh_auto_install-indep:

override_dh_auto_clean:
	dh_auto_clean
	rm -rf docs/_build

override_dh_sphinxdoc-arch:

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/fabulous-$1\.tar\.gz/,\
     dversionmangle=s/\+dfsg\d*$//,\
     repacksuffix=+dfsg1 \
     https://github.com/jart/fabulous/tags .*/v?(\d\S*)\.tar\.gz

## fabulous 0.4.0+dfsg1

=== debian/changelog ===
fabulous (0.4.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Remove fonts-noto from depends, add fonts-noto-core to recommends
    (Closes: #983247)
  * Update standards version to 4.6.1

 -- Jonathan Carter <jcc@debian.org>  Thu, 02 Sep 2021 08:09:04 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                python3-setuptools,
                python3-sphinx,
                python3-sphinxcontrib.programoutput
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Homepage: https://jart.github.io/fabulous/
 Vcs-Git: https://salsa.debian.org/python-team/packages/fabulous.git
@@ -23,12 +23,12 @@
 Breaks: python-fabulous, python-fabulous-doc, python3-fabulous-doc
 Replaces: python-fabulous, python-fabulous-doc, python3-fabulous-doc
 Architecture: any
-Depends: fonts-noto,
-         python3-pil,
+Depends: python3-pil,
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends},
          ${sphinxdoc:Depends}
+Recommends: fonts-noto-core
 Description: Python module to make your terminal output fabulous
  Fabulous is a Python library designed to make the output of terminal
  applications look fabulous. Fabulous allows you to print colors, images, and

## fabulous fpga-2.0.0b2

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation with uv environment management
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?= -q -n
SPHINXBUILD   ?= uv run --directory . --quiet sphinx-build
SOURCEDIR     = source
BUILDDIR      = build
PACKAGEDIR    = ../FABulous
PORT          ?= 8000

# Put it first so that "make" without argument is like "make help".
help:
	@echo "Please use \`make <target>\` where <target> is one of"
	@echo "  setup      to initialize the uv environment and install dependencies"
	@echo "  html       to make standalone HTML files"
	@echo "  serve      to serve built docs on localhost:$(PORT) and open browser"
	@echo "  clean      to remove build directory and generated API docs"
	@echo "  livehtml   to build docs and serve with auto-reload (requires sphinx-autobuild)"
	@echo ""
	@echo "Standard Sphinx targets:"
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

# Setup uv environment and install dependencies
setup:
	@echo "Setting up uv environment for documentation..."
	uv sync
	@echo "Installing FABulous package in editable mode..."
	uv pip install -e ..
	@echo "Documentation environment ready!"

# Build HTML documentation
html: setup
	@echo "Building final HTML documentation..."
	@$(SPHINXBUILD) -M html "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
	@echo "Documentation built successfully in $(BUILDDIR)/html"

# Serve built documentation with Python HTTP server and open browser
serve:
	@if [ ! -d "$(BUILDDIR)/html" ]; then \
		echo "Error: $(BUILDDIR)/html not found. Run 'make html' first."; \
		exit 1; \
	fi
	@echo "Starting web server on http://localhost:$(PORT)"
	@echo "Opening browser..."
	@(sleep 1 && xdg-open http://localhost:$(PORT) 2>/dev/null || \
	  open http://localhost:$(PORT) 2>/dev/null || \
	  start http://localhost:$(PORT) 2>/dev/null || \
	  echo "Please open http://localhost:$(PORT) in your browser") &
	@cd $(BUILDDIR)/html && python3 -m http.server $(PORT)

# Live reload development server
livehtml: setup
	@echo "Starting live documentation server..."
	uv run --directory . sphinx-autobuild $(SOURCEDIR) $(BUILDDIR)/html $(SPHINXOPTS)

# Clean build directory and generated API docs
clean:
	@echo "Cleaning build directory and generated API docs..."
	rm -rf $(BUILDDIR)
	rm -rf $(SOURCEDIR)/generated_doc
	@echo "Clean completed!"

# Force regeneration of AutoAPI docs (useful for development)
clean-autoapi:
	@echo "Cleaning AutoAPI generated files..."
	rm -rf $(SOURCEDIR)/generated_doc
	@echo "AutoAPI clean completed!"

.PHONY: help setup apidoc html serve livehtml clean clean-autoapi Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
sphinx >= 8.0.0
sphinx-rtd-theme >= 3.0.0
sphinxcontrib-bibtex >= 2.4.0
sphinx-prompt >= 1.5.0
fasm >= 0.0.2

=== FABulous/fabric_files/FABulous_project_template_verilog/Test/Makefile ===
MAX_BITBYTES=16384
FAB_PROJ_ROOT=..
BUILD_DIR=build
DESIGN=sequential_16bit_en
TESTBENCH=${DESIGN}_tb
TOP_WRAPPER=top_wrapper

FABRIC_FILES_DIR=${BUILD_DIR}/fabric_files
USER_DESIGN_DIR=${FAB_PROJ_ROOT}/user_design
USER_DESIGN_VERILOG=${USER_DESIGN_DIR}/${DESIGN}.v
TOP_WRAPPER_VERILOG=${USER_DESIGN_DIR}/${TOP_WRAPPER}.v
WAVEFORM_TYPE=fst

VVP_ARGS=+output_waveform=${BUILD_DIR}/${DESIGN}.${WAVEFORM_TYPE}
VVP_ARGS+=+bitstream_hex=${BUILD_DIR}/${DESIGN}.hex
ifeq ($(WAVEFORM_TYPE),fst)
    VVP_ARGS+=-fst
endif

#only add if custom_prims.v exists
ifneq ($(wildcard ${USER_DESIGN_DIR}/custom_prims.v),)
		CUSTOM_PRIMS=-extra-plib ${USER_DESIGN_DIR}/custom_prims.v
endif

.PHONY: all run_FABulous_demo full build_test_design run_simulation_emulation mkdir_build clean FAB_sim build_demo_fabric

sim: build_test_design run_simulation clean

FAB_sim: build_demo_fabric build_test_design run_simulation clean

full_sim: run_FABulous_demo build_test_design run_simulation_emulation clean

build_test_design: run_yosys run_nextpnr run_bitgen copy_files

run_simulation_emulation: run_emulation run_simulation

run_FABulous_demo:
	# Runs FABulous, generates the default fabric and generates a bitstream from the default user_design.
	# Create build folders, since FABulous removes them after it runs its simulation.
	FABulous ${FAB_PROJ_ROOT} -fs ${FAB_PROJ_ROOT}/FABulous.tcl
	mkdir -p ${BUILD_DIR}
	mkdir -p ${FABRIC_FILES_DIR}
	mv -f ${DESIGN}.hex ${BUILD_DIR}/
	mv -f ${DESIGN}.fst ${BUILD_DIR}/
	cp -fu ${USER_DESIGN_DIR}/* ${BUILD_DIR}

build_demo_fabric: mkdir_build
	# Builds the default fabric
	FABulous ${FAB_PROJ_ROOT} -ts ./build_fabulous_fabric.tcl

run_yosys: mkdir_build
	yosys -p "synth_fabulous -top ${TOP_WRAPPER} -json ${BUILD_DIR}/${DESIGN}.json ${CUSTOM_PRIMS}" ${USER_DESIGN_VERILOG} ${TOP_WRAPPER_VERILOG}

run_nextpnr: mkdir_build
	FAB_ROOT=${FAB_PROJ_ROOT} nextpnr-generic --uarch fabulous --json ${BUILD_DIR}/${DESIGN}.json -o fasm=${BUILD_DIR}/${DESIGN}.fasm

run_bitgen: mkdir_build
	bit_gen -genBitstream ${BUILD_DIR}/${DESIGN}.fasm ${FAB_PROJ_ROOT}/.FABulous/bitStreamSpec.bin ${BUILD_DIR}/${DESIGN}.bin
	python3 makehex.py ${BUILD_DIR}/${DESIGN}.bin ${MAX_BITBYTES} ${BUILD_DIR}/${DESIGN}.hex

copy_files: mkdir_build
	find ${FAB_PROJ_ROOT}/Tile/ -name '*.v' -type f -print0 | xargs -0 cp -u -t ./${FABRIC_FILES_DIR}/
	find ${FAB_PROJ_ROOT}/Fabric/ -name '*.v' -type f -print0 | xargs -0 cp -u -t ./${FABRIC_FILES_DIR}/

mkdir_build:
	mkdir -p ${BUILD_DIR}
	mkdir -p ${FABRIC_FILES_DIR}

run_simulation:
	iverilog -s ${TESTBENCH} -o ${BUILD_DIR}/${DESIGN}.vvp ${FABRIC_FILES_DIR}/* ${USER_DESIGN_VERILOG} ${TESTBENCH}.v -g2012
	vvp ${BUILD_DIR}/${DESIGN}.vvp ${VVP_ARGS}

run_emulation:
	iverilog -D EMULATION -s ${TESTBENCH} -o ${BUILD_DIR}/${DESIGN}.vvp ${BUILD_DIR}/${DESIGN}.vh ${FABRIC_FILES_DIR}/* ${USER_DESIGN_VERILOG} ${TESTBENCH}.v -g2012
	vvp ${BUILD_DIR}/${DESIGN}.vvp ${VVP_ARGS}

run_GTKWave:
	gtkwave ${BUILD_DIR}/${DESIGN}.${WAVEFORM_TYPE}

clean:
	rm -rf ${BUILD_DIR}

=== FABulous/fabric_files/FABulous_project_template_vhdl/Test/Makefile ===
MAX_BITBYTES=16384
FAB_PROJ_ROOT=..
BUILD_DIR=build
DESIGN=sequential_16bit_en
TESTBENCH=${DESIGN}_tb
TOP_WRAPPER=top_wrapper

USER_DESIGN_DIR=${FAB_PROJ_ROOT}/user_design
USER_DESIGN_VHDL=${USER_DESIGN_DIR}/${DESIGN}.vhdl
TOP_WRAPPER_VERILOG=${USER_DESIGN_DIR}/${TOP_WRAPPER}.v # Still needs to be verilog, since it is more like a constraint file for yosys
FAB_TILE_FOLDER=${FAB_PROJ_ROOT}/Tile
FAB_FABRIC_FOLDER=${FAB_PROJ_ROOT}/Fabric

GHDL=ghdl
GHDL_FLAGS=--std=08 -O2 --workdir=${BUILD_DIR}

#only add if custom_prims.v exists
ifneq ($(wildcard ${USER_DESIGN_DIR}/custom_prims.v),)
		CUSTOM_PRIMS=-extra-plib ${USER_DESIGN_DIR}/custom_prims.v
endif

.PHONY: all run_FABulous_demo full build_test_design run_simulation mkdir_build clean FAB_sim build_demo_fabric

sim: build_test_design run_simulation clean

full_sim: run_FABulous_demo build_test_design run_simulation clean

FAB_sim: build_demo_fabric build_test_design run_simulation clean

build_test_design: run_yosys run_nextpnr run_bitgen

run_FABulous_demo:
	# Runs FABulous, generates the default fabric.
	FABulous ${FAB_PROJ_ROOT} -fs ${FAB_PROJ_ROOT}/FABulous.tcl

build_demo_fabric: mkdir_build
	# Builds the default fabric only (no simulation)
	FABulous ${FAB_PROJ_ROOT} -ts ./build_fabulous_fabric.tcl

run_yosys: mkdir_build
	yosys -m ghdl -p "ghdl ${USER_DESIGN_VHDL} -e ${DESIGN}; read_verilog ${TOP_WRAPPER_VERILOG}; synth_fabulous -top ${TOP_WRAPPER} -json ${BUILD_DIR}/${DESIGN}.json ${CUSTOM_PRIMS};"

run_nextpnr: mkdir_build
	FAB_ROOT=${FAB_PROJ_ROOT} nextpnr-generic --uarch fabulous --json ${BUILD_DIR}/${DESIGN}.json -o fasm=${BUILD_DIR}/${DESIGN}.fasm

run_bitgen: mkdir_build
	bit_gen -genBitstream ${BUILD_DIR}/${DESIGN}.fasm ${FAB_PROJ_ROOT}/.FABulous/bitStreamSpec.bin ${BUILD_DIR}/${DESIGN}.bin
	python3 makehex.py ${BUILD_DIR}/${DESIGN}.bin ${MAX_BITBYTES} ${BUILD_DIR}/${DESIGN}.hex

mkdir_build:
	mkdir -p ${BUILD_DIR}

run_GTKWave:
	gtkwave ${BUILD_DIR}/${DESIGN}.fst

clean:
	rm -rf ${BUILD_DIR}

run_simulation: mkdir_build
	ulimit -s unlimited && \
	${GHDL} -a ${GHDL_FLAGS} ${FAB_FABRIC_FOLDER}/models_pack.vhdl && \
	${GHDL} -a ${GHDL_FLAGS} \
	              ${FAB_TILE_FOLDER}/LUT4AB/LUT4AB_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/LUT4AB/LUT4AB_ConfigMem.vhdl \
	              ${FAB_TILE_FOLDER}/LUT4AB/LUT4c_frame_config_dffesr.vhdl \
	              ${FAB_TILE_FOLDER}/LUT4AB/MUX8LUT_frame_config_mux.vhdl \
	              ${FAB_TILE_FOLDER}/LUT4AB/LUT4AB.vhdl \
	              ${FAB_TILE_FOLDER}/RAM_IO/RAM_IO_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/RAM_IO/RAM_IO_ConfigMem.vhdl \
	              ${FAB_TILE_FOLDER}/RAM_IO/InPass4_frame_config_mux.vhdl \
	              ${FAB_TILE_FOLDER}/RAM_IO/OutPass4_frame_config_mux.vhdl \
	              ${FAB_TILE_FOLDER}/RAM_IO/RAM_IO.vhdl \
	              ${FAB_TILE_FOLDER}/RegFile/RegFile_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/RegFile/RegFile_ConfigMem.vhdl \
	              ${FAB_TILE_FOLDER}/RegFile/RegFile_32x4.vhdl \
	              ${FAB_TILE_FOLDER}/RegFile/RegFile.vhdl \
	              ${FAB_TILE_FOLDER}/W_IO/W_IO_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/W_IO/W_IO_ConfigMem.vhdl \
	              ${FAB_TILE_FOLDER}/W_IO/IO_1_bidirectional_frame_config_pass.vhdl \
	              ${FAB_TILE_FOLDER}/W_IO/Config_access.vhdl \
	              ${FAB_TILE_FOLDER}/W_IO/W_IO.vhdl && \
	${GHDL} -a ${GHDL_FLAGS} \
	              ${FAB_TILE_FOLDER}/DSP/DSP_top/DSP_top_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/DSP/DSP_top/DSP_top_ConfigMem.vhdl \
	              ${FAB_TILE_FOLDER}/DSP/DSP_top/DSP_top.vhdl \
	              ${FAB_TILE_FOLDER}/DSP/DSP_bot/DSP_bot_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/DSP/DSP_bot/DSP_bot_ConfigMem.vhdl \
	              ${FAB_TILE_FOLDER}/DSP/DSP_bot/MULADD.vhdl \
	              ${FAB_TILE_FOLDER}/DSP/DSP_bot/DSP_bot.vhdl \
	              ${FAB_TILE_FOLDER}/DSP/DSP.vhdl && \
	${GHDL} -a ${GHDL_FLAGS} \
	              ${FAB_TILE_FOLDER}/N_term_DSP/N_term_DSP_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/N_term_DSP/N_term_DSP.vhdl \
	              ${FAB_TILE_FOLDER}/S_term_DSP/S_term_DSP_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/S_term_DSP/S_term_DSP.vhdl \
	              ${FAB_TILE_FOLDER}/N_term_RAM_IO/N_term_RAM_IO_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/N_term_RAM_IO/N_term_RAM_IO.vhdl \
	              ${FAB_TILE_FOLDER}/S_term_RAM_IO/S_term_RAM_IO_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/S_term_RAM_IO/S_term_RAM_IO.vhdl \
	              ${FAB_TILE_FOLDER}/N_term_single/N_term_single_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/N_term_single/N_term_single.vhdl \
	              ${FAB_TILE_FOLDER}/S_term_single/S_term_single_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/S_term_single/S_term_single.vhdl \
	              ${FAB_TILE_FOLDER}/N_term_single2/N_term_single2_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/N_term_single2/N_term_single2.vhdl \
	              ${FAB_TILE_FOLDER}/S_term_single2/S_term_single2_switch_matrix.vhdl \
	              ${FAB_TILE_FOLDER}/S_term_single2/S_term_single2.vhdl && \
	${GHDL} -a ${GHDL_FLAGS} \
	              ${FAB_FABRIC_FOLDER}/config_UART.vhdl \
	              ${FAB_FABRIC_FOLDER}/bitbang.vhdl \
	              ${FAB_FABRIC_FOLDER}/ConfigFSM.vhdl \
	              ${FAB_FABRIC_FOLDER}/eFPGA_Config.vhdl \
	              ${FAB_FABRIC_FOLDER}/Frame_Data_Reg.vhdl \
	              ${FAB_FABRIC_FOLDER}/Frame_Select.vhdl \
	              ${FAB_FABRIC_FOLDER}/BlockRAM_1KB.vhdl \
	              ${FAB_FABRIC_FOLDER}/eFPGA.vhdl \
	              ${FAB_FABRIC_FOLDER}/eFPGA_top.vhdl \
	              ${USER_DESIGN_DIR}/${DESIGN}.vhdl \
	              ${TESTBENCH}.vhdl && \
	${GHDL} -e ${GHDL_FLAGS} -fexplicit ${TESTBENCH} && \
	${GHDL} -r ${GHDL_FLAGS} ${TESTBENCH} --stats --ieee-asserts=disable --fst=${BUILD_DIR}/${TESTBENCH}.fst
